##############################################################################
#
# Copyright (c) 2004 TINY SPRL. (http://tiny.be) All Rights Reserved.
#                    Fabien Pinckaers <fp@tiny.Be>
#
# $Id: __init__.py 1958 2005-12-27 07:57:18Z pinky $
#
# WARNING: This program as such is intended to be used by professional
# programmers who take the whole responsability of assessing all potential
# consequences resulting from its eventual inadequacies and bugs
# End users who are looking for a ready-to-use solution with commercial
# garantees and support are strongly adviced to contract a Free Software
# Service Company
#
# This program is Free Software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License
# as published by the Free Software Foundation; either version 2
# of the License, or (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
#
##############################################################################


if __name__=='__main__':
	import locale, gettext
	import pygtk
	pygtk.require('2.0')
	import gtk
	import xml.dom.minidom
	import widget_parse

	fields = {'comment': {'type': 'text', 'string': 'Notes'}, 'payment_term': {'relation': 'account.payment.term', 'domain': [], 'type': 'many2one', 'string': 'Payment Term', 'context': ''}, 'title': {'selection': [], 'type': 'selection', 'string': 'Title', 'size': 32}, 'parent_id': {'relation': 'res.partner', 'domain': [], 'type': 'many2one', 'string': 'Main Company', 'context': ''}, 'debit': {'readonly': 1, 'type': 'float', 'string': 'Debit'}, 'ref': {'type': 'char', 'string': 'Partner ID', 'size': 64}, 'events': {'relation': 'res.partner.event', 'domain': [], 'type': 'one2many', 'string': 'events', 'context': ''}, 'vat': {'type': 'char', 'string': 'VAT', 'size': 32}, 'website': {'type': 'char', 'string': 'Website', 'size': 64}, 'address': {'relation': 'res.partner.address', 'domain': [], 'type': 'one2many', 'string': 'Contacts', 'context': ''}, 'active': {'type': 'boolean', 'string': 'Active'}, 'bank': {'type': 'char', 'string': 'Bank account', 'size': 64}, 'lang': {'selection': [('en', 'English'), (False, '/')], 'type': 'selection', 'string': 'Language', 'size': 2}, 'credit_limit': {'type': 'float', 'string': 'Limit Debit'}, 'name': {'required': True, 'type': 'char', 'string': 'Name', 'size': 64}, 'credit': {'readonly': 1, 'type': 'float', 'string': 'Credit'}, 'category_id': {'relation': 'res.partner.category', 'domain': [], 'type': 'many2many', 'string': 'Categories', 'context': ''}}

	view = """<?xml version="1.0"?>
		<form string="Partners">
		<notebook>
			<page string="General">
				<separator string="General Information" colspan="4"/>
				<field name="name" select="1"/>
				<field name="title" domain="[('domain', '=', 'partner')]"/>
				<field name="ref" select="1"/>
				<field name="lang" select="1"/>
				<newline/>
				<field name="address" widget="one2many_form" colspan="4" nolabel="1" select="1" view_form="res.partner.address.form2"/>
				<separator string="Categories" colspan="3"/>
				<field name="category_id" colspan="4" select="1" nolabel="1"/>
			</page>
			<page string="Extra Info">
				<field name="credit" select="1"/>
				<field name="credit_limit" select="1"/>
				<field name="debit" select="1"/>
				<field name="payment_term" />
				<newline/>
				<field name="vat" select="1"/>
				<field name="active" select="1" />
				<field name="parent_id" colspan="3" select="1"/>
				<field name="bank"/>
				<field name="website"/>
				<separator string="Notes" colspan="4"/>
				<field name="comment" colspan="4" string=""/>
			</page>
			<page string="Event History">
				<field name="events" colspan="4" string="" widget="one2many_list"/>
			</page>
		</notebook>
	</form>"""

	_fields_view_get = lambda **args: (view,fields)

	p = widget_parse.widget_parse(triggers = {'fields_view_get':_fields_view_get} )
	widget = p.parse_view('res.partner')

	window = gtk.Window()
	window.add(widget.widget)
	window.show_all()
	gtk.main()



