import interface
import xml.dom.minidom

import form

parsers = {
	'form': form.form,
}

class widget_parse(interface.parser_interface):
	def parse(self, model, root_node, fields):
		widget = None
		for node in root_node.childNodes:
			if not node.nodeType == node.ELEMENT_NODE:
				continue
			if node.localName in parsers:
				widget = parsers[node.localName](self.window, self.parent, model, self.attrs, node, fields)
			else:
				print 'Invalid XML tag ', node.localName
		return widget

	def parse_view(self, model, view_id=None):
		view, fields = self.trigger('fields_view_get')
		root_node = xml.dom.minidom.parseString(view)
		return self.parse(model, root_node, fields)

